// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'SMCells.pas' rev: 6.00

#ifndef SMCellsHPP
#define SMCellsHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Variants.hpp>	// Pascal unit
#include <SMIBase.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <DB.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Smcells
{
//-- type declarations -------------------------------------------------------
typedef void __fastcall (__closure *TOnColumnWidth)(System::TObject* Sender, int SheetIndex, int ColumnNo, int Width);

typedef void __fastcall (__closure *TOnRowHeight)(System::TObject* Sender, int SheetIndex, int RowNo, int Height);

typedef void __fastcall (__closure *TOnDimensions)(System::TObject* Sender, int SheetIndex, int FirstRow, int LastRow, int FirstColumn, int LastColumn);

typedef void __fastcall (__closure *TOnCellValue)(System::TObject* Sender, int SheetIndex, int Row, int Column, int FormatIndex, const OleVariant &Value, Classes::TAlignment Alignment);

typedef void __fastcall (__closure *TOnGetCellValue)(System::TObject* Sender, int SheetIndex, int Row, int Column, OleVariant &Value);

typedef void __fastcall (__closure *TOnSheet)(System::TObject* Sender, AnsiString Caption, int Index, bool &Skip);

#pragma pack(push, 1)
struct TBIFFRecordHeader
{
	Word ID;
	Word Len;
} ;
#pragma pack(pop)

typedef void __fastcall (__closure *TOnRecord)(System::TObject* Sender, TBIFFRecordHeader Header, const Byte * Data);

class DELPHICLASS TSMICell;
class PASCALIMPLEMENTATION TSMICell : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	OleVariant FValue;
	Classes::TAlignment FAlignment;
	int FFormatIndex;
	
public:
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property OleVariant Value = {read=FValue, write=FValue};
	__property Classes::TAlignment Alignment = {read=FAlignment, write=FAlignment, nodefault};
	__property int FormatIndex = {read=FFormatIndex, write=FFormatIndex, nodefault};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TSMICell(void) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TSMICell(void) : Classes::TPersistent() { }
	#pragma option pop
	
};


class DELPHICLASS TSpreadSheetCols;
class PASCALIMPLEMENTATION TSpreadSheetCols : public Classes::TList 
{
	typedef Classes::TList inherited;
	
public:
	TSMICell* __fastcall GetCell(int Col);
	void __fastcall SetCell(int Col, TSMICell* Value);
public:
	#pragma option push -w-inl
	/* TList.Destroy */ inline __fastcall virtual ~TSpreadSheetCols(void) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TSpreadSheetCols(void) : Classes::TList() { }
	#pragma option pop
	
};


class DELPHICLASS TSpreadSheetRow;
class PASCALIMPLEMENTATION TSpreadSheetRow : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
public:
	int Index;
	TSpreadSheetCols* Cols;
	__fastcall virtual TSpreadSheetRow(void);
	__fastcall virtual ~TSpreadSheetRow(void);
};


class DELPHICLASS TSpreadSheetCells;
class PASCALIMPLEMENTATION TSpreadSheetCells : public Classes::TList 
{
	typedef Classes::TList inherited;
	
private:
	int FColCount;
	int FRowCount;
	int FUsedColCount;
	int FUsedRowCount;
	
public:
	bool AutoUsedRangeDetect;
	bool IsIncrementalLoad;
	__fastcall virtual TSpreadSheetCells(void);
	__fastcall virtual ~TSpreadSheetCells(void);
	int __fastcall AddRow(int i);
	void __fastcall RemoveRow(int i);
	virtual void __fastcall Clear(void);
	OleVariant __fastcall GetValue(int Col, int Row);
	void __fastcall SetValue(int Col, int Row, const OleVariant &Value, Classes::TAlignment Alignment, int FormatIndex);
	__property int UsedColCount = {read=FUsedColCount, nodefault};
	__property int UsedRowCount = {read=FUsedRowCount, nodefault};
	__property int ColCount = {read=FColCount, write=FColCount, nodefault};
	__property int RowCount = {read=FRowCount, write=FRowCount, nodefault};
};


class DELPHICLASS TSpreadSheet;
class PASCALIMPLEMENTATION TSpreadSheet : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
public:
	TSpreadSheetCells* Cells;
	AnsiString Caption;
	Classes::TList* ColWidths;
	__fastcall virtual TSpreadSheet(void);
	__fastcall virtual ~TSpreadSheet(void);
	AnsiString __fastcall PlainText();
};


class DELPHICLASS TSpreadSheets;
class PASCALIMPLEMENTATION TSpreadSheets : public Classes::TList 
{
	typedef Classes::TList inherited;
	
public:
	__fastcall virtual ~TSpreadSheets(void);
	HIDESBASE int __fastcall Add(void);
	HIDESBASE void __fastcall Remove(int Index);
	virtual void __fastcall Clear(void);
	TSpreadSheet* __fastcall Spreadsheet(int Index);
	TSpreadSheet* __fastcall SheetByName(const AnsiString Value);
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TSpreadSheets(void) : Classes::TList() { }
	#pragma option pop
	
};


class DELPHICLASS TCustomSpreadSheetFile;
class PASCALIMPLEMENTATION TCustomSpreadSheetFile : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	AnsiString FFileName;
	TOnColumnWidth FOnColumnWidth;
	TOnRowHeight FOnRowHeight;
	TOnDimensions FOnDimensions;
	TOnCellValue FOnCellValue;
	TOnGetCellValue FOnGetCellValue;
	TOnSheet FOnSheet;
	TOnRecord FOnRecord;
	
__published:
	__property AnsiString FileName = {read=FFileName, write=FFileName};
	__property TOnColumnWidth OnColumnWidth = {read=FOnColumnWidth, write=FOnColumnWidth};
	__property TOnRowHeight OnRowHeight = {read=FOnRowHeight, write=FOnRowHeight};
	__property TOnDimensions OnDimensions = {read=FOnDimensions, write=FOnDimensions};
	__property TOnCellValue OnCellValue = {read=FOnCellValue, write=FOnCellValue};
	__property TOnGetCellValue OnGetCellValue = {read=FOnGetCellValue, write=FOnGetCellValue};
	__property TOnSheet OnSheet = {read=FOnSheet, write=FOnSheet};
	__property TOnRecord OnRecord = {read=FOnRecord, write=FOnRecord};
public:
	#pragma option push -w-inl
	/* TComponent.Create */ inline __fastcall virtual TCustomSpreadSheetFile(Classes::TComponent* AOwner) : Classes::TComponent(AOwner) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TComponent.Destroy */ inline __fastcall virtual ~TCustomSpreadSheetFile(void) { }
	#pragma option pop
	
};


typedef void __fastcall (__closure *TOnLoadProgress)(System::TObject* Sender, int Position, int TotalSize);

#pragma option push -b-
enum TSMIColumnNameKind { nkAlphabet, nkFieldName };
#pragma option pop

class DELPHICLASS TSpreadSheetFile;
class PASCALIMPLEMENTATION TSpreadSheetFile : public TCustomSpreadSheetFile 
{
	typedef TCustomSpreadSheetFile inherited;
	
private:
	TOnLoadProgress FOnLoadProgress;
	TSMIColumnNameKind FNameKind;
	void __fastcall DimsEvent(System::TObject* Sender, int SheetIndex, int FirstRow, int LastRow, int FirstColumn, int LastColumn);
	void __fastcall SetCellEvent(System::TObject* Sender, int SheetIndex, int Row, int Column, int FormatIndex, const OleVariant &Value, Classes::TAlignment Alignment);
	void __fastcall GetCellEvent(System::TObject* Sender, int SheetIndex, int Row, int Column, OleVariant &Value);
	void __fastcall SheetEvent(System::TObject* Sender, AnsiString Caption, int Index, bool &Skip);
	void __fastcall ColumnWidthEvent(System::TObject* Sender, int SheetIndex, int ColumnNo, int Width);
	
protected:
	#pragma pack(push, 1)
	TBIFFRecordHeader BufferHeader;
	#pragma pack(pop)
	
	void __fastcall UpdateProgress(int Position, int TotalSize);
	virtual void __fastcall ApplyEvents(void);
	
public:
	TSpreadSheets* Sheets;
	Smibase::TProgressPreviewCallback ReadProgressCallback;
	__fastcall virtual TSpreadSheetFile(Classes::TComponent* AOwner);
	__fastcall virtual ~TSpreadSheetFile(void);
	virtual void __fastcall LoadFromFile(const AnsiString FileName);
	virtual void __fastcall LoadFromStream(Classes::TStream* AStream);
	virtual void __fastcall BeforeLoad(void);
	virtual void __fastcall AfterLoad(void);
	virtual void __fastcall LoadRecord(int RecNo);
	
__published:
	__property TSMIColumnNameKind NameKind = {read=FNameKind, write=FNameKind, default=0};
	__property TOnLoadProgress OnLoadProgress = {read=FOnLoadProgress, write=FOnLoadProgress};
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE int __fastcall GetSpreadSheetColID(AnsiString s, int MaxColCount);
extern PACKAGE AnsiString __fastcall GetSpreadSheetColByID(int ID);

}	/* namespace Smcells */
using namespace Smcells;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// SMCells
